package me.zhanshi123.tutorialmenu;

import com.neteasemc.spigotmaster.SpigotMaster;
import me.zhanshi123.tutorialmenu.config.ConfigManager;
import me.zhanshi123.tutorialmenu.config.MenuButtonConfig;
import org.bukkit.Bukkit;
import org.bukkit.plugin.java.JavaPlugin;

public final class TutorialMenu extends JavaPlugin {
    private static TutorialMenu instance;
    private SpigotMaster spigotMaster;

    private final String NAMESPACE = "testMenu";
    private final String SERVER_SYSTEM_NAME = "testMenuDev";
    private final String CLIENT_SYSTEM_NAME = "testMenuBeh";
    private final String CLIENT_UI_LOADED_EVENT = "ClientUiLoadedEvent";
    private final String SERVER_MENU_EVENT = "ServerMenuEvent";
    private final String CLIENT_MENU_CLICKED_EVENT = "ClientMenuClickedEvent";


    public static TutorialMenu getInstance() {
        return instance;
    }

    @Override
    public void onEnable() {
        instance = this;
        ConfigManager.getInstance().loadConfig();
        spigotMaster = (SpigotMaster) Bukkit.getPluginManager().getPlugin("SpigotMaster");
        spigotMaster.listenForEvent(NAMESPACE, CLIENT_SYSTEM_NAME, CLIENT_UI_LOADED_EVENT, (player, map) ->
                spigotMaster.notifyToClient(player, NAMESPACE, SERVER_SYSTEM_NAME, SERVER_MENU_EVENT, ConfigManager.getInstance().getClientData()));
        spigotMaster.listenForEvent(NAMESPACE, CLIENT_SYSTEM_NAME, CLIENT_MENU_CLICKED_EVENT, (player, map) -> {
            int index = (int) map.get("index");
            MenuButtonConfig menuButtonConfig = ConfigManager.getInstance().getMenuConfigs().get(index);
            if (menuButtonConfig == null) {
                getLogger().warning("玩家 " + player.getName() + " 发送了一个不正确的菜单数据");
                return;
            }
            menuButtonConfig.dispatchCommand(player);
        });
    }

    @Override
    public void onDisable() {

    }
}
