package me.zhanshi123.tutorialmenu.config;

import me.zhanshi123.tutorialmenu.TutorialMenu;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.util.*;
import java.util.stream.Collectors;

public class ConfigManager {
    private FileConfiguration config;
    private static final ConfigManager instance = new ConfigManager();
    private final Map<Integer, MenuButtonConfig> menuConfigs = new HashMap<>();
    private final Map<String, Object> clientData = new HashMap<>();

    public static ConfigManager getInstance() {
        return instance;
    }

    public ConfigManager() {
        File file = new File(TutorialMenu.getInstance().getDataFolder(), "config.yml");
        if (!file.exists()) {
            TutorialMenu.getInstance().saveResource("config.yml", false);
        }
        config = YamlConfiguration.loadConfiguration(file);
    }

    public Map<String, Object> getClientData() {
        return clientData;
    }

    public Map<Integer, MenuButtonConfig> getMenuConfigs() {
        return menuConfigs;
    }

    public void loadConfig() {
        config.getKeys(false).forEach(key -> {
            int index = config.getInt(key + ".idx");
            String texture = config.getString(key + ".texture");
            String text = config.getString(key + ".text");
            List<String> commands = config.getStringList(key + ".commands");
            menuConfigs.put(index, new MenuButtonConfig(index, texture, text, commands));
        });
        clientData.put("data", menuConfigs.values()
                .stream()
                .map(MenuButtonConfig::serializePython)
                .collect(Collectors.toList()));
    }

}
